Name: openssl
Version: 0.9.7d
Release: alt1

Summary: OpenSSL - Secure Sockets Layer and cryptography shared libraries and tools
License: distributable
Group: System/Base
Url: http://www.%name.org

Source: %url/source/%name-%version.tar.bz2
Source1: %name-config
Source2: Makefile.certificate
Source3: make-dummy-cert

Patch11: %name-0.9.7d-owl-alt-glibc-enable_secure.patch
Patch12: %name-0.9.7d-rh-default-commonName.patch
Patch13: %name-0.9.7d-rh-soversion.patch
Patch14: %name-0.9.7d-alt-configure-arm.patch

%define openssldir %_localstatedir/ssl
%define old_openssldir %_libdir/ssl
%def_enable compat

Provides: %_bindir/openssl-config
Provides: %openssldir
Provides: SSL
Conflicts: SSLeay
Requires: libssl = %version-%release

%package -n libssl
Summary: OpenSSL shared libraries
Group: System/Libraries
Conflicts: openssl < 0.9.6c-alt2

%package -n libssl-devel
Summary: OpenSSL include files and development libraries
Group: Development/C
Provides: %_bindir/openssl-config
Provides: %name-devel = %version-%release
Obsoletes: %name-devel
Requires: libssl = %version-%release
# manpage clash: crypto(3).
Conflicts: erlang <= 0:R9C.0-alt2

%package -n libssl-devel-static
Summary: OpenSSL static libraries
Group: Development/C
Provides: %name-devel-static = %version-%release
Obsoletes: %name-devel-static
Requires: libssl-devel = %version-%release

%package doc
Summary: OpenSSL documentation and demos
Group: Development/C
Requires: %name = %version-%release

%description
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols with full-strength cryptography world-wide.  The project is
managed by a worldwide community of volunteers that use the Internet to
communicate, plan, and develop the OpenSSL tookit and its related
documentation.

OpenSSL is based on the excellent SSLeay library developed from Eric A.
Young and Tim J. Hudson.  The OpenSSL toolkit is licensed under an
Apache-style licence, which basically means that you are free to get and
use it for commercial and non-commercial purposes.

This package contains the base OpenSSL cryptography and SSL/TLS tools.

%description -n libssl
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols with full-strength cryptography world-wide.  The project is
managed by a worldwide community of volunteers that use the Internet to
communicate, plan, and develop the OpenSSL tookit and its related
documentation.

OpenSSL is based on the excellent SSLeay library developed from Eric A.
Young and Tim J. Hudson.  The OpenSSL toolkit is licensed under an
Apache-style licence, which basically means that you are free to get and
use it for commercial and non-commercial purposes.

This package contains the OpenSSL shared libraries.

%description -n libssl-devel
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols with full-strength cryptography world-wide.  The project is
managed by a worldwide community of volunteers that use the Internet to
communicate, plan, and develop the OpenSSL tookit and its related
documentation.

OpenSSL is based on the excellent SSLeay library developed from Eric A.
Young and Tim J. Hudson.  The OpenSSL toolkit is licensed under an
Apache-style licence, which basically means that you are free to get and
use it for commercial and non-commercial purposes.

This package contains the the OpenSSL cryptography and SSL/TLS
include files and development libraries required when building
OpenSSL-based applications.

%description -n libssl-devel-static
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols with full-strength cryptography world-wide.  The project is
managed by a worldwide community of volunteers that use the Internet to
communicate, plan, and develop the OpenSSL tookit and its related
documentation.

OpenSSL is based on the excellent SSLeay library developed from Eric A.
Young and Tim J. Hudson.  The OpenSSL toolkit is licensed under an
Apache-style licence, which basically means that you are free to get and
use it for commercial and non-commercial purposes.

This package contains the the OpenSSL cryptography and SSL/TLS
static libraries required when developing OpenSSL-based statically
linked applications.

%description doc
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols with full-strength cryptography world-wide.  The project is
managed by a worldwide community of volunteers that use the Internet to
communicate, plan, and develop the OpenSSL tookit and its related
documentation.

OpenSSL is based on the excellent SSLeay library developed from Eric A.
Young and Tim J. Hudson.  The OpenSSL toolkit is licensed under an
Apache-style licence, which basically means that you are free to get and
use it for commercial and non-commercial purposes.

This package contains the the OpenSSL cryptography and SSL/TLS extra
documentation and demos required when developing applications.

%prep
%setup -q
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1

# Fix makefiles.
subst 's/\\\$(SHLIB_MAJOR)\.\\\$(SHLIB_MINOR)/\\$(VERSION)/g' Configure
subst 's/\${SHLIB_MAJOR}\.\${SHLIB_MINOR}/\${VERSION}/g' Makefile.org
find -type f -name Makefile\* -print0 |
	xargs -r0 %__grep -FZl 'cp $$' -- |
	xargs -r0 %__subst -p 's/cp \$\$/cp -pv $$/g' --

# Fix perl path.
find -type f -print0 |
	xargs -r0 %__grep -FZl '/usr/.*bin/perl[0-9]*' -- |
	xargs -r0 %__perl -pi -e 's|/usr/.*bin/perl[0-9]*|/usr/bin/perl|g' --

# Fix compilation flags.
%__perl -pi -e "s/-O.(?: -fomit-frame-pointer)?(?: -m.86)?/${RPM_OPT_FLAGS}/;" \
	Configure
%build
ADD_ARGS=
%ifarch %ix86
	ADD_ARGS=linux-elf
%ifarch i386
	ADD_ARGS="$ADD_ARGS 386"
%endif
%endif
%ifarch ppc
	ADD_ARGS=linux-ppc
%endif
%ifarch alpha alphaev5
	ADD_ARGS=linux-alpha-gcc
%endif
%ifarch alphaev56 alphapca56 alphaev6 alphaev67
	ADD_ARGS=linux-alpha+bwx-gcc
%endif
%ifarch sparc
	ADD_ARGS=linux-sparcv8
%endif
%ifarch sparcv9
	ADD_ARGS=linux-sparcv9
%endif

./Configure shared -DSSL_ALLOW_ADH --prefix=%prefix --openssldir=%openssldir $ADD_ARGS

# SMP-incompatible build.
make Makefile.ssl
make -C crypto/objects obj_dat.h
make
touch -r libcrypto.so.%version libcrypto-stamp
touch -r libssl.so.%version libssl-stamp
make rehash
make test

%install
# The make_install macro doesn't work here.
make install \
	INSTALL_PREFIX=$RPM_BUILD_ROOT \
	MANDIR=%_mandir

# Fail if one of shared libraries was rebuit.
if [ libcrypto.so.%version -nt libcrypto-stamp -o \
     libssl.so.%version -nt libssl-stamp ]; then
	echo 'Shared library was rebuilt by "make install".'
	exit 1
fi

# Fail if the openssl binary is statically linked against OpenSSL at this
# stage (which could happen if "make install" caused anything to rebuild).
LD_LIBRARY_PATH=`pwd` ldd $RPM_BUILD_ROOT%_bindir/openssl |tee %name.libs
%__grep -qw libssl %name.libs
%__grep -qw libcrypto %name.libs

# Install %name-config script.
%__install -p -m755 %SOURCE1 $RPM_BUILD_ROOT%_bindir/%name-config
%__subst -p 's,%%version,%version,g;s,%%openssldir,%openssldir,g' \
	$RPM_BUILD_ROOT%_bindir/%name-config

# Relocate shared libraries from %_libdir/ to /lib/.
%__mkdir_p $RPM_BUILD_ROOT/lib
for f in $RPM_BUILD_ROOT%_libdir/*.so; do
	t=`objdump -p "$f" |%__awk '/SONAME/ {print $2}'`
	[ -n "$t" ]
	%__ln_s -nf ../../lib/"$t" "$f"
done
%__mv $RPM_BUILD_ROOT%_libdir/*.so.* $RPM_BUILD_ROOT/lib/

# Relocate %name.cnf from %%openssldir/ to %_sysconfdir/%name/.
%__mkdir_p $RPM_BUILD_ROOT%_sysconfdir/%name
%__mv $RPM_BUILD_ROOT%openssldir/%name.cnf $RPM_BUILD_ROOT%_sysconfdir/%name/
%__ln_s `relative %_sysconfdir/%name/%name.cnf %openssldir/%name.cnf` $RPM_BUILD_ROOT%openssldir/

# Rename man pages, fix references.
find $RPM_BUILD_ROOT%_mandir -name '* *' -print -delete
for f in passwd.1 err.3 rand.3 threads.3 config.5; do
	name="${f%%.*}"
	sect="${f##*.}"
	%__mv -v $RPM_BUILD_ROOT%_mandir/man"$sect"/{,ssl}"$f"
	find $RPM_BUILD_ROOT%_mandir -type f -print0 |
		xargs -r0 %__grep -FZl "\\fI$name\\fR\\|($sect)" -- |
		xargs -r0 %__subst -p "s/\\\\fI$name\\\\fR\\\\|($sect)/\\\\fIssl$name\\\\fR\\\\|($sect)/" --
	find $RPM_BUILD_ROOT%_mandir -type l |while read link; do
		[ "$(readlink -n "$link")" = "$f" ] || continue
		%__ln_s -fv "ssl$f" "$link"
	done
done
%__ln_s sslconfig.5 $RPM_BUILD_ROOT%_mandir/man5/openssl.cnf

# Make backwards-compatibility symlink to ssleay.
%__ln_s -nf %name $RPM_BUILD_ROOT%_bindir/ssleay

# Install a makefile for generating keys and self-signed certs,
# and a script for generating them on the fly.
%__install -p -m644 %SOURCE2 $RPM_BUILD_ROOT%openssldir/certs/Makefile
%__install -p -m644 %SOURCE3 $RPM_BUILD_ROOT%openssldir/certs/make-dummy-cert

pushd $RPM_BUILD_ROOT%openssldir/misc
mv CA.sh CA
popd

%define docdir %_docdir/%name-%version
%__mkdir_p $RPM_BUILD_ROOT%docdir
%__install -p -m644 CHANGES* LICENSE NEWS README* $RPM_BUILD_ROOT%docdir/
bzip2 -9 $RPM_BUILD_ROOT%docdir/CHANGES*
%__cp -a demos doc $RPM_BUILD_ROOT%docdir/

%post -n libssl -p %post_ldconfig_sys
%postun -n libssl -p %postun_ldconfig

%if_enabled compat
%pre
[ $1 -gt 1 ] || exit 0
if [ ! -e %_sysconfdir/%name -a ! -L %_sysconfdir/%name -a -e %old_openssldir/%name.cnf ]; then
	%__mkdir_p %_sysconfdir/%name &&
	%__cp -a %old_openssldir/%name.cnf %_sysconfdir/%name/
fi
if [ ! -e %openssldir -a ! -L %openssldir -a -d %old_openssldir ]; then
	%__cp -a %old_openssldir %openssldir
fi
%endif #compat

%files -n libssl
/lib/*
%dir %docdir
%docdir/[A-Z]*

%files -n libssl-devel
%_bindir/openssl-config
%_libdir/*.so
%_libdir/pkgconfig/*
%_includedir/*
%_mandir/man3/*

%files -n libssl-devel-static
%_libdir/*.a

%files
%_bindir/*
%dir %_sysconfdir/%name
%config(noreplace) %_sysconfdir/%name/*.cnf
%dir %openssldir
%openssldir/*.cnf
%openssldir/misc
%openssldir/certs
%dir %openssldir/lib
%dir %attr(700,root,root) %openssldir/private
%_mandir/man[157]/*

%files doc
%dir %docdir
%docdir/[a-z]*

%changelog
* Sat May 08 2004 Dmitry V. Levin <ldv@altlinux.org> 0.9.7d-alt1
- Updated to 0.9.7d.
- Reviewed patches.
- Applied RH's soname convention.

* Wed Mar 17 2004 Dmitry V. Levin <ldv@altlinux.org> 0.9.6m-alt1
- Updated to 0.9.6m.

* Wed Mar 17 2004 Dmitry V. Levin <ldv@altlinux.org> 0.9.6l-alt2
- Fixed null-pointer assignment during SSL handshake
  (CAN-2004-0079).

* Fri Nov 07 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.6l-alt1
- Updated to 0.9.6l.
- For non-i386 ix86 platforms, relaxed textrel check.

* Tue Sep 30 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.6k-alt1
- Updated to 0.9.6k:
  + Fix various ASN1 parsing bugs.
  + SSL/TLS protocol fix for unrequested client certificates.

* Thu Aug 28 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.6j-alt2
- Fixed linux-elf-arm architecture support (sbolshakov@, #2804).
- Shared %_bindir/openssl-config between openssl and
  libssl-devel subpackages (fixes #2806).

* Sat Apr 12 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.6j-alt1
- Updated to 0.9.6j.

* Thu Mar 20 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.6i-alt3
- Applied patch against Klima-Pokorny-Rosa attack.

* Tue Mar 18 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.6i-alt2
- Applied blinding patch from OpenSSL team,
  to defend against timing attack on RSA keys.

* Wed Feb 19 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.6i-alt1
- Updated to 0.9.6i.

* Thu Dec 12 2002 Dmitry V. Levin <ldv@altlinux.org> 0.9.6h-alt1
- Updated to 0.9.6h.
- Merged Owl changes:
  * Fri Nov 15 2002 Solar Designer <solar@owl.openwall.com>
  - Dropped the patch removing -Wl,-Bsymbolic which is no longer needed with
    0.9.6g and/or after dropping the explicit "make build-shared".
  - Dropped RSAref stuff.

* Sun Sep 29 2002 Dmitry V. Levin <ldv@altlinux.org> 0.9.6g-alt3
- Fixed glibc/crypto compatibility patch.

* Sat Sep 21 2002 Dmitry V. Levin <ldv@altlinux.org> 0.9.6g-alt2
- Fixed libssl linkage:
  Don't do an explicit "make build-shared", it's not needed and
  could only cause harm (link libssl against libcrypto statically).
- FHS fixes (#0000915):
  + changed %%openssldir from %_libdir/ssl to %_localstatedir/ssl;
  + moved %name.cnf from %%openssldir/ to %_sysconfdir/%name/;
  + on upgrade, copy old %%openssldir to new location;
  + added %name-config script to provide current %%openssldir location.
- Renamed %name-devel subpackage to libssl-devel.
- Renamed %name-devel-static subpackage to libssl-devel-static.

* Mon Aug 19 2002 Dmitry V. Levin <ldv@altlinux.org> 0.9.6g-alt1
- 0.9.6g; asn1_lib patch merged upstream.

* Mon Aug 05 2002 Dmitry V. Levin <ldv@altlinux.org> 0.9.6e-alt1
- Updated to 0.9.6e, recent security patch merged upstream.
- Added two post-0.9.6e changes from the CVS which correct the recent ASN.1
  parsing vulnerability fixes (Owl).

* Wed Jul 31 2002 Solar Designer <solar@owl.openwall.com>
- Updated to 0.9.6e, dropping the shared-on-SPARC and the official
  security patches (both are now included).

* Mon Jul 29 2002 Dmitry V. Levin <ldv@altlinux.org> 0.9.6d-alt2
- Various security fixes (see CHANGES).

* Mon May 13 2002 Dmitry V. Levin <ldv@alt-linux.org> 0.9.6d-alt1
- Updated to 0.9.6d.
- Added a patch by Ben Laurie for "openssl dgst" to behave on read errors.
- Properly restrict the instruction set in assembly code when building for i386 (Owl).

* Wed Apr 10 2002 Dmitry V. Levin <ldv@alt-linux.org> 0.9.6c-alt3
- Fixed %_bindir/%name linkage.
- Relocate shared libs to /lib/.

* Thu Mar 21 2002 Dmitry V. Levin <ldv@alt-linux.org> 0.9.6c-alt2
- libssl: Conflicts: %%name < %%version-%%release.

* Tue Jan 15 2002 Dmitry V. Levin <ldv@alt-linux.org> 0.9.6c-alt1
- 0.9.6c
- Relocated docs.

* Wed Jul 11 2001 Dmitry V. Levin <ldv@altlinux.ru> 0.9.6b-alt1
- 0.9.6b

* Fri Jun 22 2001 Dmitry V. Levin <ldv@altlinux.ru> 0.9.6a-alt2
- Changed two memcpy() calls to memmove() (nalin).
- Added a script for creating dummy certificates (nalin).

* Mon May 14 2001 Dmitry V. Levin <ldv@altlinux.ru> 0.9.6a-alt1
- 0.9.6a
- Keep standard soname scheme.
- Do not provide crypt symbol (solar).
- Use __libc_enable_secure variable (solar).
- Link %_bindir/%name dinamically with shared libraries from libssl subpackage (solar).

* Wed Apr 04 2001 Dmitry V. Levin <ldv@altlinux.ru> 0.9.6-ipl2mdk
- Moved shared libraries to libssl subpackage.
- Moved static libraries to devel-static subpackage.

* Thu Sep 28 2000 Dmitry V. Levin <ldv@fandra.org> 0.9.6-ipl1mdk
- 0.9.6

* Wed May 31 2000 Dmitry V. Levin <ldv@fandra.org>
- 0.9.5a

* Fri Apr 28 2000 Dmitry V. Levin <ldv@fandra.org>
- separate %name-doc package
- 0.9.5

* Sun Dec  5 1999 Dmitry V. Levin <ldv@fandra.org>
- Fandra adaptions

* Sun Nov 28 1999 Arne Coucheron <arneco@online.no>
  [0.9.4-3]
- config file moved to /var/ssl due to problems when it stays in /etc

* Tue Aug 17 1999 Arne Coucheron <arneco@online.no>
  [0.9.4-2]
- the source rpm was corrupt, so this is just a rerelase

* Wed Aug 11 1999 Arne Coucheron <arneco@online.no>
  [0.9.4-1]

* Sun Jun 20 1999 Arne Coucheron <arneco@online.no>
  [0.9.3a-1]
- several changes
